<?php
require_once('api.config.php');
session_start();

// --------------------------------------------------------------------------
// PHP $_SESSION변수에 Access Token 정보가 존재하지 않거나
// PHP $_SESSION변수에 존재하는 Access Token 정보가 만료되었다면 다시 요청합니다.
if( ! isset($_SESSION['ecplaza_access_token_info']) ||
	$_SESSION['ecplaza_access_token_info']['expires'] < time()) {

	$parm = array();
	$parm['client_id'] = $ecplaza_client_id; // api.config.php를 참조하세요.
	$parm['client_secret'] = $ecplaza_client_secret; // api.config.php를 참조하세요.
	$parm['redirect_uri'] = $ecplaza_redirect_uri; // api.config.php를 참조하세요.
	$parm['response_type'] = 'code'; // 고정 값 (상수)

 	// Request Token은 GET방식만 지원이 됩니다.
	$url = 'https://api.ecplaza.net/oauth/requestToken?' . http_build_query($parm);
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
	// WEB용 API는 API 신청 시 입력한 `Callback 경로`로 redirect되기 때문에 아래 옵션이 필요합니다.
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);
	$res = curl_exec($ch); // 결과 값은 JSON 형식입니다.
	curl_close($ch);

	// Access Token 정보를 PHP에서 처리하기 쉬운 객체로 변환합니다. (예제는 Array형)
	$token_info = json_decode($res, TRUE);

	if(isset($token_info['error'])) {
		echo $token_info['error'] . ' => ' . $token_info['error_description'];
		exit;
	} else {
		$_SESSION['ecplaza_access_token_info'] = $token_info;
	}
}
// --------------------------------------------------------------------------

$parm = array();
$parm['client_id'] = $ecplaza_client_id;
$parm['client_secret'] = $ecplaza_client_secret;
$parm['redirect_uri'] = $ecplaza_redirect_uri;
$parm['access_token'] = $_SESSION['ecplaza_access_token_info']['access_token'];
// `q`필드는 검색 쿼리 옵션입니다.
// 옵션명과 옵션값은 `:`로 구분하며, 다중 옵션은 `;;`로 구분합니다.
$parm['q'] = '';
$parm['q'] = 'companyname:Valter';

$url = 'https://api.ecplaza.net/apis/1/offer';
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
curl_setopt($ch, CURLOPT_POST, TRUE);
curl_setopt($ch, CURLOPT_POSTFIELDS, $parm);
$search_res = curl_exec($ch); // 결과 값은 JSON 형식입니다.
curl_close($ch);

// 검색 결과를 PHP에서 처리하기 쉬운 객체로 변환합니다. (예제는 Array형)
$result = json_decode($search_res, TRUE);
if(isset($result['error'])) { // 
		echo $result['error'] . ' => ' . $result['error_message'];
} else {
	if($result['total_count'] > 0) {
		foreach ($result['data'] as $info) {
			foreach ($info as $k => $v) {
				echo $k . ' = ' . $v . '<br/>';
			}
		}
	}
}
?>